Remove nesting selectors because are not support in old browsers

2024-12-09 10:38 - Kevin Zhang

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 6.0.2   

Resolution: Fixed Affected version: 6.0.1

Description

database manager version

mysql  Ver 8.0.26 for Linux on x86_64 (Source distribution)

Ruby version

ruby 3.2.3 (2024-01-18 revision 52bb2ac0a6) [x86_64-linux]

Redmine version

6.0.1

Google Chrome version

109.0.5414.120

sidebar and filter form not correct displayed in old browsers (chrome, safari) because of nesting selector in application.css not

supported

svg {

  &.icon-svg {

    stroke: #169;

    fill: none;

    stroke-width: 1.5;

    vertical-align: middle;

  }

  &.s20 {

    width: 1.25rem;

    height: 1.25rem;

  }

  &.s18 {

    width: 1.125rem;

    height: 1.125rem;

  }

  &.s14 {

    width: 0.875rem;

    height: 0.875rem;

  }

  &.s12 {

    width: 0.75rem;

    height: 0.75rem;

  }

}

Associated revisions

Revision 23378 - 2024-12-10 23:12 - Marius BĂLTEANU

Refactors nested CSS selectors in order to improve compatibility with older browsers (#41957).

Revision 23381 - 2024-12-11 00:37 - Marius BĂLTEANU
Merge r23378 from trunk to 6.0-stable (#41957).

Revision 23387 - 2024-12-11 07:32 - Marius BĂLTEANU

Refactors nested CSS selectors (#41957).

Patch by Katsuya HIDAKA (user:hidakatsuya).

Revision 23390 - 2024-12-11 07:46 - Marius BĂLTEANU

Backports r23387 to 6.0-stable (#41957).

History

#1 - 2024-12-09 10:43 - Kevin Zhang

- File filter form not displayed.jpg added

- File application-css.png added

- File browsers compatible.png added

#2 - 2024-12-09 23:12 - Holger Just

- Status changed from New to Confirmed

This feature is apparently available since Chrome 112 (released 2023-04-04). See

https://caniuse.com/mdn-css_selectors_nesting

https://developer.mozilla.org/en-US/docs/Web/CSS/Nesting_selector#browser_compatibility

Note that in addition to the rules quoted here, there are also other rules (e.g. those added in r23130 for #41321) which require Chrome >= 120

(released 2023-12-05). To solve this, we could re-formulate these rules to not require nesting or we could document minimum browser requirements.

As our rules are not that complicated, it may be worthwhile to remove the & nesting here to still allow "medium-old" browsers.

#3 - 2024-12-09 23:13 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

- Target version set to 6.0.2

I agree, I will include this change in 6.0.2

#4 - 2024-12-10 22:15 - Marius BĂLTEANU

- Subject changed from & nesting selector not support in old browsers to Remove nesting selectors because are not support in old browsers

#5 - 2024-12-11 00:39 - Marius BĂLTEANU

- Status changed from Confirmed to Resolved

- Resolution set to Fixed

#6 - 2024-12-11 00:40 - Marius BĂLTEANU

Fixes committed and merged to 6.0-stable branch.

#7 - 2024-12-11 00:40 - Marius BĂLTEANU

- Status changed from Resolved to Closed

#8 - 2024-12-11 05:06 - Katsuya HIDAKA

The browser support for CSS Nesting is nearly identical to that of the CSS Nesting selector (&).

For example, the fix in #41821 won't work in older browsers.

Since CSS Nesting and the CSS Nesting selector (&) are functionally related features, wouldn’t it be more consistent to address CSS Nesting as

well?

diff --git a/app/assets/stylesheets/application.css b/app/assets/stylesheets/application.css

index 1707bc172..8590db99a 100644

--- a/app/assets/stylesheets/application.css

+++ b/app/assets/stylesheets/application.css

@@ -1745,10 +1745,10 @@ td.gantt_selected_column .gantt_hdr,.gantt_selected_column_container {

   display: inline-flex;

   align-items: center;

   vertical-align: middle;
+}

-  svg {

-    flex-shrink: 0;

-  }

+.icon svg, .icon-only svg {

+  flex-shrink: 0;

 }

 a.icon:hover svg, a.icon-only:hover svg {

diff --git a/app/assets/stylesheets/wiki_syntax.css b/app/assets/stylesheets/wiki_syntax.css

index 068bae969..de266e62c 100644

--- a/app/assets/stylesheets/wiki_syntax.css

+++ b/app/assets/stylesheets/wiki_syntax.css

@@ -25,24 +25,21 @@ body { font-family: var(--fonts-main); font-size: 0.75rem; color: #444; }

 pre, code {font-family: Consolas, Menlo, "Liberation Mono", Courier, monospace; }

 table th {

   padding-top: 1em;

-

-  img {

-    border: 1px solid #bbb;

-    opacity: 0.7;

-  }

-

-  .syntax-pre {

-    display: inline-block;

-    border: 1px solid #bbb;

-    width: 18px;

-    height: 18px;

-

-    &:before {

-      content: "pre";

-      font-size: 0.625rem;

-      color: #666;

-    }

-  }

+}

+table th img {

+  border: 1px solid #bbb;

+  opacity: 0.7;

+}

+table th .syntax-pre {

+  display: inline-block;

+  border: 1px solid #bbb;

+  width: 18px;

+  height: 18px;

+}

+table th .syntax-pre:before {

+  content: "pre";

+  font-size: 0.625rem;

+  color: #666;

 }

 table td { background-color: #f5f5f5; height: 2em; vertical-align: middle;}

 table td code { font-size: 1.2em; }

 If this discussion should be handled in a separate issue, I’m happy to do so.

#9 - 2024-12-11 07:32 - Marius BĂLTEANU

Katsuya HIDAKA wrote in #note-8:

The browser support for CSS Nesting is nearly identical to that of the CSS Nesting selector (&).

For example, the fix in #41821 won't work in older browsers.

Since CSS Nesting and the CSS Nesting selector (&) are functionally related features, wouldn’t it be more consistent to address CSS Nesting as

well?

[...]

If this discussion should be handled in a separate issue, I’m happy to do so.

 Committed, thanks!
Files

filter form not displayed.jpg 228 KB 2024-12-09 Kevin Zhang

application-css.png 114 KB 2024-12-09 Kevin Zhang

browsers compatible.png 180 KB 2024-12-09 Kevin Zhang
